%define apache_version 1.3.22
%define apache_release 2mdk
%define python_version 2.2
%define python_release 5mdk
%define name mod_python
%define version 2.7.6
%define release 1mdk
%define html_dir /var/www/html
%define apachebase %{_sysconfdir}/httpd


Summary: 	Apache/Python Integration
Name: 		%{name}
Version: 	%{version}
Release: 	%{release}
Group: 		System/Servers
URL:		http://www.modpython.org
Source0: 	http://www.modpython.org/dist/%{name}-%{version}.tar.bz2
License: 	Apache License
BuildRoot: 	%{_tmppath}/%{name}-root
Requires:	python => %{python_version}
PreReq: 	apache >= %{apache_version} , python >= %{python_version}
BuildRequires: 	apache-devel >= %{apache_version} apache-source >= %{apache_version}
BuildRequires:	libpython-devel => %{python_version}
BuildRoot:	%{_tmppath}/%{name}-root

%description 
Mod_python allows embedding Python within the Apache http server for a
considerable boost in performance and added flexibility in designing web b
ased applications.

The RPM installs a small example in /var/www/html/mod_python_test which can be
accessed as http://localhost/mod_python/some/path/which/doesn/t/matter

%prep
%setup -q
./configure --with-includedir=/usr/include/apache --with-apache=/usr/src/apache_1.3.22 --with-apxs=%{_sbindir}/apxs --prefix=%{_prefix}

%build
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%make

mkdir -p $RPM_BUILD_ROOT%{_libdir}/apache

%install
rm -rf $RPM_BUILD_ROOT
# Install module
install -D -s -m 0755 src/mod_python.so $RPM_BUILD_ROOT%{_libdir}/apache-extramodules/mod_python.so
# Install site-packages files
mkdir -p $RPM_BUILD_ROOT%{_libdir}/python%{python_version}/site-packages/mod_python
install lib/python/mod_python/* \
	$RPM_BUILD_ROOT%{_libdir}/python%{python_version}/site-packages/mod_python
mkdir -p $RPM_BUILD_ROOT%{html_dir}/mod_python_test
python %{_libdir}/python%{python_version}/compileall.py $RPM_BUILD_ROOT%{_libdir}/python%{python_version}/site-packages/mod_python

cat <<CAT>$RPM_BUILD_ROOT%{html_dir}/mod_python_test/.htaccess
SetHandler python-program
PythonHandler pythonhandler
CAT

cat <<CAT>$RPM_BUILD_ROOT%{html_dir}/mod_python_test/pythonhandler.py 
from mod_python import apache

def handler(req):
    req.send_http_header()
    req.write("Hello to the World from "+req.uri+"!")
    return apache.OK 
CAT

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ $1 = "1" ]; then
   #We're in Install mode, add module to the config files
   for config in %{apachebase}/conf/{httpd,httpd-perl}.conf; do
     if [ -x %{_sbindir}/advxaddmod -a -e $config ]; then
       %{_sbindir}/advxaddmod $config \
        extramodules/mod_python.so mod_python.c python_module \
        define=HAVE_PYTHON
     fi
   done
   if [ -x %{_sbindir}/AESctl ]; then %{_sbindir}/AESctl update;fi
fi

if [ $1 -gt 1 ]; then
   #We're in *upgrade mode*. Since we can't be sure the configuration files
   #are sane, remove module from the conf files to clean them, re-add again 
   #in a way that the older module we're replacing won't try to erase (the 
   #post scripts were broken on some packages), and finally clean the module
   #specific config file so it's compatible with the upgrade.
   for config in %{apachebase}/conf/{httpd,httpd-perl}.conf; do
     if [ -x %{_sbindir}/advxdelmod -a -e $config ]; then
       %{_sbindir}/advxdelmod $config \
        extramodules/mod_python.so mod_python.c python_module \
        define=HAVE_PYTHON
        $config
     fi
     if [ -x %{_sbindir}/advxaddmod -a -e $config ]; then
       %{_sbindir}/advxaddmod $config \
        extramodules/mod_python.so mod_python.c python_module \
        define=HAVE_PYTHON
     fi
   done
   if [ -x %{_sbindir}/AESctl ]; then %{_sbindir}/AESctl update; fi
fi

%postun
if [ $1 = "0" ]; then
   for config in %{apachebase}/conf/{httpd,httpd-perl}.conf; do
     if [ -x %{_sbindir}/advxdelmod -a -e $config ]; then
       %{_sbindir}/advxdelmod $config \
        extramodules/mod_python.so mod_python.c python_module \
        define=HAVE_PYTHON
     fi
   done
   if [ -x %{_sbindir}/AESctl ]; then %{_sbindir}/AESctl update;fi
fi

%files
%defattr(-,root,root)
%doc doc-html/*.html
%doc COPYRIGHT CREDITS NEWS README
%{_libdir}/apache-extramodules/mod_python.so
%{html_dir}/mod_python_test
%{_libdir}/python%{python_version}/site-packages/mod_python

%changelog
* Thu Jan 17 2002 Christian Belisle <cbelisle@mandrakesoft.com> 2.7.6-1mdk
- First MDK package, spec adaptation.

* Fri Nov 10 2000 Michael A. Peters <mpeters@abriasoft.com>
- Updated for RH7 (/var/www opposed to /home/httpd)
- restart apache if its running upon install/deinstall,
- changed %postun script to %preun and only execute it
- if package is being uninstalled, not upgraded. Also
- added sed script so that proper lines would be uncommented
- if they existed before rpm installs.

* Tue Oct 31 2000 Grisha Trubetskoy <grisha@ispol.com>
- Combined efforts of Mads Kiilerich and Sean Reifschneider

* Tue Sep 24 2000 Sean Reifschneider <jafo-rpms@tummy.com>
- Initial RPM version.

* Mon Jun 13 2000 Mads Kiilerich <mads@kiilerich.com>
- Made initial version of mod_python rpm

